"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _enjoyWebSupport = require("enjoy-web-support");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

//距离失效3s 前重新请求签名
var JSSDKCONFIGTIME = 7197000;
//获取微信签名的跨域接口
var GETWXSIGN = "//openapi.elong.com/wx/sign";
//获取微信jssdk连接
var WXJSSDKURL = "//res.wx.qq.com/open/js/jweixin-1.0.0.js ";
//默认weixin appId
var WEIXINID = "f09ef811411445bdbf93e34aebdc0c90";

var jsApiList = ['getLocation', 'hideMenuItems', 'showMenuItems', 'hideAllNonBaseMenuItem', 'onMenuShareTimeline', 'onMenuShareAppMessage', 'onMenuShareQQ', 'onMenuShareQZone'];
var weixinSign;

exports.default = {
	callback: function callback() {},

	ready: function ready(callback, weixinId) {
		var _this = this;

		return _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
			var oScript;
			return regeneratorRuntime.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							if (!window["wx"]) {
								console.log("请正确引用jssdk");
								oScript = document.createElement("script");

								oScript.type = "text/javascript";
								oScript.src = location.protocol + WXJSSDKURL;
								document.body.appendChild(oScript);
							}

							_this.callback = callback;

							_this.weixinId = weixinId;

							_context.next = 5;
							return _this.updateSign();

						case 5:
						case "end":
							return _context.stop();
					}
				}
			}, _callee, _this);
		}))();
	},
	updateSign: function updateSign() {
		var now = new Date().getTime();
		// window.configCallback = this.configCallback;
		// window.__WEIXINCALLBACK__ = this.callback;
		//判断签名是否失效
		if (weixinSign && +weixinSign.timestamp + JSSDKCONFIGTIME <= now) {
			return this.getSign();
		} else if (!weixinSign) {
			return this.getSign();
		} else {
			wx.ready(this.callback);
			return;
		}
	},
	getSign: function getSign() {
		var _this2 = this;

		return _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
			var nowTime, getSignUrl, result;
			return regeneratorRuntime.wrap(function _callee2$(_context2) {
				while (1) {
					switch (_context2.prev = _context2.next) {
						case 0:
							_context2.prev = 0;
							nowTime = new Date().getTime();
							getSignUrl = location.protocol + GETWXSIGN + '?url=' + encodeURIComponent(location.protocol + "//" + location.hostname + location.pathname + location.search) + "&id=" + _this2.weixinId + "&v=" + nowTime;
							_context2.next = 5;
							return (0, _enjoyWebSupport.Fetch)(getSignUrl, {
								method: 'Get'
							});

						case 5:
							result = _context2.sent;

							_this2.configCallback(result);
							_context2.next = 12;
							break;

						case 9:
							_context2.prev = 9;
							_context2.t0 = _context2["catch"](0);

							console.log(JSON.stringify(_context2.t0));

						case 12:
						case "end":
							return _context2.stop();
					}
				}
			}, _callee2, _this2, [[0, 9]]);
		}))();
	},
	configCallback: function configCallback(resp) {
		if (resp.code == "200" && "wx" in window) {
			var data = resp.data;
			weixinSign = {
				appId: data.appid,
				timestamp: data.timestamp,
				nonceStr: data.nonce,
				signature: data.sign
			};
			this.config(weixinSign);
			wx.ready(this.callback);
		}
	},
	config: function config(userConfig) {
		if (userConfig.jsApiList) {
			userConfig.jsApiList.forEach(function (apiName) {
				if (jsApiList.indexOf(apiName) === -1) {
					jsApiList.push(apiName);
				}
			});
			delete userConfig.jsApiList;
		}

		if (userConfig.appId && userConfig.timestamp && userConfig.nonceStr && userConfig.signature) {
			wx.config(_extends({}, userConfig, {
				debug: false,
				jsApiList: jsApiList
			}));
			return true;
		}
		return false;
	}
};